#!/usr/bin/python3
# -*- coding: utf-8 -*-
 
import sys
import os
 
EJUDGE = bool(os.environ.get("EJUDGE", "0") == "1")
VERBOSE = bool(os.environ.get("VERBOSE", "0") == "1")
YANDEX = False
 
if EJUDGE:
    OK = 0
    PE = 4
    WA = 5
    CF = 6
    AC = 8
else:
    OK = 0
    WA = 1
    PE = 2
    CF = 3
 
LOG = ""
#sys.stdout.reconfigure(encoding='utf-8')
#sys.stderr.reconfigure(encoding='utf-8')
 
def quit(status, log="", score=0):
    # Если задано значение параметра log, то выводится это значение, иначе выводится глобальная переменная LOG
    if EJUDGE and not VERBOSE and status != PE:
        log = "Полные протоколы проверки будут доступны после окончания олимпиады"
    sys.stderr.write(log if log else LOG)
    if EJUDGE:
        if status == WA or status == OK:
            sys.stdout.write(str(score) + "\n0\n" + str(AC) + "\n")
    elif YANDEX:
        if status == WA or status == OK:
            sys.stdout.write("$" + str(score) + "$\n")
            status = OK
    else:
        sys.stdout.write("Score: " + str(score) + "\n")
    sys.exit(status)
 
fin = open(sys.argv[2], "r")
ans = fin.readline().strip()
 
if (len(ans) == 0):
    quit(PE, "Ответ пустой")
 
ans = ans.replace("A", "a")
ans = ans.replace("B", "b")
ans = ans.replace("А", "a") # русская
ans = ans.replace("М", "b") # русская
ans = ans.replace("Ф", "a") # русская
ans = ans.replace("ф", "a") # русская
ans = ans.replace("И", "b") # русская
ans = ans.replace("и", "b") # русская
#ans = ans.replace(chr(8722), "-") # неправильный минус
 
for char in ans:
    if char not in " ab+-*/0123456789()":
        quit(PE, "Ответ содержит недопустимый символ: ''" + char + "''" + "\n")
if "**" in ans:
    quit(PE, "В ответе не может использоваться ''**''" + "\n")
if "//" in ans:
    quit(PE, "В ответе не может использоваться ''//''" + "\n")
#if "/" in ans:
    #quit(PE, "В ответе не может использоваться ''/''" + "\n")
ALL_PASSED = True
 
ANSWERS = {
"(a + b) / 6" : 100,
}
#"a * b + a + b + 2" : 30,
#"a * b + a + b - 2" : 30,
#"a * b + a + b + 3" : 30,
#"a * b + a + b - 3" : 30,
#"a * b + a + b + 1" : 30,
#"a * b + a + b - 1" : 30,
#"a * b - a + b" : 30,
#"a * b + a - b" : 30,
#"-a * b + a + b" : 30,
#"a * a + a + b" : 30,
#"b * b + a + b" : 30,
#"a * b + a + a" : 30,
#"a * b + b + b" : 30,
#}
 
EPS = 1e-6
try:
    for i in range(2, 32):
        for j in range(1, i // 2 + 1):
            a = 2 * (i + j)
            b = 2 * (i + i - j)
            for sample in list(ANSWERS.keys()):
                if abs(eval(ans) - eval(sample)) > EPS:
                    del ANSWERS[sample]
except ZeroDivisionError as E:
    quit(WA, "При вычислении выражения возникло деление на ноль.\n", 0)
except Exception as E:
    quit(PE, "Некорректное арифметическое выражение.\n")
 
if len(ANSWERS) > 1:
    quit(CF, "Два подходящих варианта ответа в критериях оценивания.\n" + str(ANSWERS), 0)
 
if len(ANSWERS) == 0:
    quit(WA, "Это неправильный ответ\n", 0)
 
for sample in ANSWERS:
    if ANSWERS[sample] == 100:
        quit(OK, "Это правильный ответ\n", ANSWERS[sample])
    #else:
        #quit(WA, "Ответ эквивалентен выражению " + sample + ".\nЭто неправильный ответ, вы ошиблись в одном символе\n", ANSWERS[sample])
