#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
import os
import re

POLYGON = bool("polygon" in os.environ.get("APPDATA", "0").lower())

OK = 0
WA = 1
PE = 2
CF = 3

LOG = ""
sys.stdout.reconfigure(encoding='utf-8')
sys.stderr.reconfigure(encoding='utf-8')

# Формат ответа - пять целых положительных чисел
ANSWER_REGEXP = "^[ ,;+\\-#\\u2116\\u2212]+$"

def quit(status, log="", score=0):
    # Набранные баллы
    if POLYGON:
        sys.stdout.write(str(score) + " баллов; ")
    else:
        sys.stdout.write(str(score) + "\n")
    
    # Протокол проверки
    sys.stderr.write(log if log else LOG)
    
    # Статус
    sys.exit(status)


fin = open(sys.argv[2], "r", encoding="utf8")
ans = fin.readlines()

i = 0
while i < len(ans):
    ans[i] = ans[i].strip()
    if ans[i] == "":
        ans.pop(i)
    else:
        i += 1

if len(ans) != 5:
    quit(PE, "В ответе должно быть ровно 5 строк")

for i in range(5):
    if re.compile(ANSWER_REGEXP).fullmatch(ans[i]) is None:
        quit(PE, "Каждая строка ответа должна содержать только символы +-# " + ans[i])
    ans[i] = ans[i].strip().replace(" ", "").replace(",", "").replace(";", "").replace(chr(0x2212), "-").replace(chr(0x2116), "#")

TIMES =   [37,     3 * 60,   3 * 60 + 17,  3 * 60 + 19,  4 * 60 + 57]
CORRECT = ["++#+", "****#",  "++#+##+#+",  "#--#-###+",  "#-++#####++"]

def check(finish, ans, correct):
    global LOG
    LOG += "Проверка для времени " + str(finish) + ": "
    t = 0
    for c in ans:
        if t < 30:
            delta = 1
        elif t < 60:
            delta = 5
        elif t < 120:
            delta = 10
        else:
            delta = 60
        if c == "#":
            t += 30
        elif c == "+":
            t += delta
        elif c == "-" and t > 0:
            t -= delta
    if t != finish:
        LOG += "Последовательность неверна.\n"
        return 0
    elif len(ans) < len(correct):
        LOG += "Ответ участника короче, чем верный ответ!\n"
        quit(CF)
    elif len(ans) == len(correct):
        LOG += "Ответ правильный и наилучший.\n"
        return 20
    else:
        LOG += "Ответ не наилучший.\n"
        return max(5, 15 - 2 * (len(ans) - len(correct)))

score = 0
for i in range(5):
    score += check(TIMES[i], ans[i], CORRECT[i])
quit(OK if score == 100 else WA, score=score)
