#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
import os
import re

POLYGON = bool("polygon" in os.environ.get("APPDATA", "0").lower())

OK = 0
WA = 1
PE = 2
CF = 3

LOG = ""
sys.stdout.reconfigure(encoding='utf-8')
sys.stderr.reconfigure(encoding='utf-8')

# Формат ответа - четыре целых положительных числа
ANSWER_REGEXP = "^[0123456789]+$"

def quit(status, log="", score=0):
    # Набранные баллы
    if POLYGON:
        sys.stdout.write(str(score) + " баллов; ")
    else:
        sys.stdout.write(str(score) + "\n")
    
    # Протокол проверки
    sys.stderr.write(log if log else LOG)
    
    # Статус
    sys.exit(status)


fin = open(sys.argv[2], "r", encoding="utf8")
ans = fin.read().strip().split()

if len(ans) != 4:
    quit(PE, "В ответе должно быть ровно 4 числа")

for num in ans:
    if re.compile(ANSWER_REGEXP).fullmatch(num) is None:
        quit(PE, "Каждая часть ответа должна быть целым положительным числом")

CORR_ANS = [358, 194, 54, 14]
count_ans = 0
for i in range(4):
    if int(ans[i]) == CORR_ANS[i]:
        count_ans += 1

if count_ans == 4:
    quit(OK, "Все ответы правильные\n", score=100)
else:
    quit(WA, "Только " + str(count_ans) + " ответов из 4 правильные", score=count_ans * 25)
